#include "stdafx.h"

#include "VideoThread.h"

#include "SaveLiveVideoDoc.h"
#include "VideoManager.h"

UINT VideoFrameThread(LPVOID lParam)
{
	CSaveLiveVideoDoc *pDoc = (CSaveLiveVideoDoc*)lParam;

	if(!pDoc)
		return FALSE;

	for( ;; )
	{
		DWORD threadResult = ::WaitForSingleObject(pDoc->_killNextFrame.m_hObject, 1); 

		if(threadResult == WAIT_OBJECT_0)
			break;
		
		int result = pDoc->_videoManager->NextFrame();

		if(result == 1 && pDoc->_viewWnd && pDoc->_viewWnd->GetSafeHwnd())
		{
			if(pDoc->_videoManager->IsVideoStreamRecord())
				pDoc->_videoManager->VideoSaveNextFrame();

			pDoc->_viewWnd->Invalidate(FALSE);
		}

		pDoc->_newImgReady.ResetEvent();
		pDoc->_newImgReady.SetEvent();
	}

	pDoc->_nextFrameEnd.ResetEvent(); 
	pDoc->_nextFrameEnd.SetEvent();

	return TRUE;
}